#include <iostream>

#include <QApplication>
#include <QWidget>
#include <QFrame>
#include <QHBoxLayout>
#include <QFile>
#include <QGridLayout>
#include <QSizePolicy>
#include <QMenuBar>
#include <QMenu>
#include <QInputDialog>
#include <QDir>

#include "player.h"

// """ Version 0.9 """

//using namespace std;

int main(int argc, char* argv[]) {
    QApplication app(argc, argv);

    QWidget window;
    window.setGeometry(20,50,1270,590);

    QMenuBar menuBar(&window);
    QMenu *fileMenu;
    QMenu *workMenu;
    fileMenu=menuBar.addMenu("&Datei");
    workMenu=menuBar.addMenu("&Bearbeiten");
    fileMenu->addAction("Be&enden", exit);
    workMenu->addAction("&IP-Adresse", exit);

    QFrame videoWidget;
    Player player(&videoWidget);

    QListWidget liste;
    for(int x=1;x<=player.get_Sender();x++){
        liste.addItem(player.get_Name(x));
    }
    QObject::connect(&liste, SIGNAL(itemClicked(QListWidgetItem*)), &player, SLOT(play(QListWidgetItem*)));

    QSizePolicy sp=liste.sizePolicy();
    sp.setHorizontalPolicy(QSizePolicy::Fixed);
    liste.setSizePolicy(sp);

    QGridLayout gridLayout;
    gridLayout.setMargin(0);
    gridLayout.setSpacing(0);
    gridLayout.addWidget(&menuBar, 0, 0, 1, 0);
    gridLayout.addWidget(&videoWidget, 1, 0);
    gridLayout.addWidget(&liste, 1, 1);
    window.setLayout(&gridLayout);

    window.show();

    return app.exec();
}
